#include "WebUtil.h"
#include <stdlib.h>
#include <string.h>
#include "Windows.h"
//#include "Winnls.h"

#define WEBUTIL_NOERROR					"NOERROR"
#define WEBUTIL_BADPARAM				"Bad param."
#define WEBUTIL_MEMORYERROR				"Memory not enough."
#define WEBUTIL_ERR_BOUNDARYPOSTDATA	"Bad boundary post data."
#define WEBUTIL_ERR_CONTENTSTYPE		"Bad content type."

/*
inline int max(int a, int b)
{
	return (a > b) ? a : b;
}

inline int min(int a, int b)
{
	return (a < b) ? a : b;
}
*/

// ----------------------------------------------------------------------------
// WSTRSTR쐬
// ----------------------------------------------------------------------------
char* WStrToStrAlloc(unsigned short* pT)
{
	int nLen;
	char* pStr = NULL;

	nLen = WideCharToMultiByte(CP_ACP, 0, pT, -1, NULL, 0, NULL, FALSE);
	pStr = (char*)malloc( nLen );
	memset(pStr, 0, nLen);

	if( pStr == NULL )
	{
		return NULL;
	}

	nLen = WideCharToMultiByte(CP_ACP, 0, pT, -1, pStr, nLen, NULL, FALSE);

	return pStr;
}

// ----------------------------------------------------------------------------
// 啶\L16i𐔎ɕϊ֐
// ----------------------------------------------------------------------------
inline char AtoH( char c )
{
	if( '0' <= c && c <= '9' ) return c - '0';
	if( 'A' <= c && c <= 'F' ) return c - 'A' + 10;
	if( 'a' <= c && c <= 'f' ) return c - 'a' + 10;
	return 0;
}

// ----------------------------------------------------------------------------
// 16i𐔎ɕϊ֐
// ----------------------------------------------------------------------------
unsigned long HtoDWORD(char* src)
{
	unsigned long dw = 0;

	if( !src )
		return 0;

	for( int ii = 0; ii < 8,*src; ii++ )
	{
		dw <<= 4;
		dw += AtoH( *src++ );
	}
	return dw;
}

// ----------------------------------------------------------------------------
// %XX ϊ
// ----------------------------------------------------------------------------
void UnEscape( char* src )
{
	char* dst;
	for( dst=src; *src; src++ )
	{
		if( *src == '%' )
		{
			if( *(src+1) != '%' )
			{
#ifdef SHx
				*dst++ = (AtoH(*++src)) + (AtoH(*++src)<<4);
#else
				*dst++ = (AtoH(*++src)<<4) + AtoH(*++src);
#endif
			}
			else
			{
				// %%
				*dst++ = *src++;
			}
		}
		else if( *src == '+' )
		{
			*dst++ = ' ';
		}
		else
		{
			*dst++ = *src;
		}
	}
	*dst++ = '\0';
}

//-----------------------------------------------------------------------------
// ɕϊ܂B
//-----------------------------------------------------------------------------
int TOLOWER( int c )
{
	return (( c >= 'A' && c <= 'Z' ) ? c += ('a'-'A') : c);
}

//-----------------------------------------------------------------------------
// ɕϊB
//-----------------------------------------------------------------------------
char *STRLWR( char *string )
{
	if( !string )
		return NULL;

	while( *string )
	{
		*string = TOLOWER( *string );
	}
	return string;
}

//-----------------------------------------------------------------------------
// 񒆂̕ƂĔr܂B
//-----------------------------------------------------------------------------
int STRICMP( const char *str1, const char *str2 )
{
	do
	{
		if( TOLOWER(*str1) != TOLOWER(*str2) )
			return TOLOWER(*str2) - TOLOWER(*str1);
	}while( *str1++ && *str2++ );

	return 0;
}

//-----------------------------------------------------------------------------
// 񒆂̕ƂĔr܂B
//-----------------------------------------------------------------------------
int STRNICMP( const char *str1, const char *str2, size_t n )
{
	do
	{
		if( !n-- ) return 0;
		if( TOLOWER(*str1) != TOLOWER(*str2) )
			return TOLOWER(*str2) - TOLOWER(*str1);
	}while( *str1++ && *str2++ );

	return 0;
}

//-----------------------------------------------------------------------------
// mallocgĕ܂
// Jfree𗘗pĉB
//-----------------------------------------------------------------------------
char* STRDUP( const char* strSrc )
{
	int nLen;
	char* pNew;

	if( strSrc == NULL ) return NULL;

	nLen = strlen(strSrc);
	//pNew = new char[nLen + 1];
	pNew = (char*)malloc(nLen+1);

	if( pNew )
	{
		strcpy( pNew, strSrc );
	}
	return pNew;
}

static int IsFormUrlencoeded(MyHash* pEnv)
{
	char* pszEncType = pEnv->GetValue("CONTENT_TYPE");
	if( pszEncType )
	{
		if( 0 == STRNICMP(pszEncType, "application/x-www-form-urlencoded", 33 ))
		{
			return 1;
		}
	}
	return 0;
}

static int IsFormFromMultipart(MyHash* pEnv)
{
	char* pszEncType = pEnv->GetValue("CONTENT_TYPE");
	if( pszEncType )
	{
		if( 0 == STRNICMP(pszEncType, "multipart/form-data", 19 ) )
		{
			return 1;
		}
	}
	return 0;
}

//*****************************************************************************
//
// GetMemoryBlockFromUrlEncoded
//	@detail
//		urlencoded񂩂KeyɑΉvalue̒l擾
//
// ----------------------------------------------------------------------------
//
//	@param
//		const char* pszQS	urlencoded
//							key1=value1&key2=value2
//		const char* pszKey	L[
//		char* pBlock		ꂽl̐擪AhX
//	@return
//		int					ꂽl̒
//
//*****************************************************************************
static int GetMemoryBlockFromUrlEncoded(const char* pszQS, const char* pszKey, char* pBlock)
{
	int ii;

	if( pszQS == NULL || pszKey == NULL )
		return 0;

	char* p = strstr( pszQS, pszKey );

	if( p == NULL )
	{
		return 0;
	}

	while( (*p != '=') && (*p != '\0') ) *p++;

	if( *p == '\0' )
		return 0;

	p++;
	pBlock = p;

	for( ii = 0;(*p != '&') && (*p != '\0') ; ii++, p++ );

	return ii;

}


//*****************************************************************************
//
// QueryValueFromString
//	@detail
//		urlencoded񂩂KeyɑΉvalue̒l擾
//
// ----------------------------------------------------------------------------
//
//	@param
//		const char* pszQS	[in ]urlencoded
//								key1=value1&key2=value2
//		const char* pszKey	[in ]L[
//		char* pszValue		[out]ꂽlobt@
//		int nValueLen		[in ]obt@̒
//								0ƃobt@ɕKvȒ擾ł
//	@return
//		int					ꂽl̒
//
//*****************************************************************************
static int QueryValueFromString(const char* pszQS, const char* pszKey, char* pszValue, int nValueLen)
{
	if( pszQS == NULL || pszKey == NULL )
		return 0;

	char* p = strstr( pszQS, pszKey );

	if( p == NULL && pszValue != NULL && nValueLen )
	{
		*pszValue = '\0';
		return 0;
	}

	while( (*p != '=') && (*p != '\0') ) *p++;

	if( *p == '\0' )
		return 0;

	p++;
	int ii;

	if( pszValue == NULL || nValueLen == 0)
	{
		for( ii = 0;(*p != '&') && (*p != '\0'); ii++, p++ );
	}
	else
	{
		for( ii = 0;(*p != '&') && (*p != '\0') && (nValueLen); nValueLen--, ii++ )
		{
			*pszValue++ = *p++;
		}

		if( nValueLen )
			*pszValue = '\0';
	}

	return ii;

}

// ============================================================================
//	WebUtil
// ============================================================================
WebUtil::WebUtil(MyHash* pEnv/* = NULL*/, MyVarMem* pBody/* = NULL*/, MyVarMem* pRes/* = NULL */)
{
	char* p;
	m_pszLastError = WEBUTIL_NOERROR;

	Set(pEnv, pBody, pRes);

	if( p = m_pEnv->GetValue("QUERY_STRING") )
		UnEscape(p);

	if( p = m_pEnv->GetValue("CONTENT_TYPE") )
	{
		if( 0 == STRICMP( p, "application/x-www-form-urlencoded" ) &&
			m_pBody != NULL )
		{
			UnEscape( (char*)m_pBody->GetBuffer() );
		}
	}
}

WebUtil::~WebUtil()
{
}

void WebUtil::Set(MyHash* pEnv, MyVarMem* pBody, MyVarMem* pRes)
{
	m_pEnv = pEnv;
	m_pBody = pBody;
	m_pRes = pRes;
}
//*****************************************************************************
//
// GetItem
//	@detail
//		POST/urlencoded POST/multipart GET/urlencoded񂩂l
//
// ----------------------------------------------------------------------------
//
//	@param
//		const char* pszKey	[in ]L[
//		MyVarMem* pvmRet	[out]ꂽl
//								0ƃobt@ɕKvȒ擾ł
//	@return
//		int					ꂽl̒
//
//*****************************************************************************
int WebUtil::GetItem(const char* pszKey, MyVarMem* pvmRet)
{
	// ]΂ʐ̏
	if( pvmRet == NULL )
	{
		return 0;
	}

	if( IsPost() )
		return GetPostItem(pszKey, pvmRet);

	return GetQueryItem(pszKey, pvmRet);
}

//*****************************************************************************
//
// GetItem
//	@detail
//		POST/urlencoded POST/multipart GET/urlencoded񂩂l
//
// ----------------------------------------------------------------------------
//
//	@param
//		const char* pszKey	[in ]L[
//		char* pszValue		[out]ꂽlobt@
//		int nValueLen		[in ]obt@̒
//								0ƃobt@ɕKvȒ擾ł
//	@return
//		int					ꂽl̒
//
//*****************************************************************************
int WebUtil::GetItem(const char* pszKey, char* pszValue, int nValueLen)
{
	// ]΂ʐ̏
	if( pszValue )
	{
		memset( pszValue, 0, nValueLen );
	}

	if( IsPost() )
		return GetPostItem(pszKey, pszValue, nValueLen);

	return GetQueryItem(pszKey, pszValue, nValueLen);
}

//*****************************************************************************
//
// GetItem
//	@detail
//		POST/urlencoded POST/multipart GET/urlencoded񂩂l
//
// ----------------------------------------------------------------------------
//
//	@param
//		const char* pszKey	[in ]L[
//		MyVarMem* pvmRet	[out]ꂽl
//								0ƃobt@ɕKvȒ擾ł
//	@return
//		int					ꂽl̒
//
//*****************************************************************************
int WebUtil::GetItemInt(const char* pszKey)
{
	if( IsPost() )
		return GetPostItemInt(pszKey);

	return GetQueryItemInt(pszKey);
}

//*****************************************************************************
//
// GetQueryItem
//	@detail
//		urlencoded񂩂KeyɑΉvalue̒l擾
//		GET \bhp
//
// ----------------------------------------------------------------------------
//
//	@param
//		const char* pszKey	[in ]
//		MyVarMem* pVM		[out]ꂽl
//	@return
//		int					ꂽl̒
//
//*****************************************************************************
int WebUtil::GetQueryItem(const char* pszKey, MyVarMem* pVM)
{
	pVM->Clear();

	int nLen = GetQueryItem(pszKey, NULL, 0);

	if( nLen == 0 )
	{
		m_pszLastError = WEBUTIL_NOERROR;
		return 0;
	}

	char* pTmp = new char[nLen+1];

	if( pTmp != NULL && nLen != 0 )
	{
		pTmp[nLen] = '\0';
		GetQueryItem(pszKey, pTmp, nLen);
		return pVM->Add(pTmp, nLen);
	}

	return 0;
}

//*****************************************************************************
//
// GetQueryItem
//	@detail
//		urlencoded񂩂KeyɑΉvalue̒l擾
//		GET \bhp
//
// ----------------------------------------------------------------------------
//
//	@param
//		const char* pszKey	[in ]L[
//		char* pszValue		[out]ꂽlobt@
//		int nValueLen		[in ]obt@̒
//								0ƃobt@ɕKvȒ擾ł
//	@return
//		int					ꂽl̒
//
//*****************************************************************************
int WebUtil::GetQueryItem(const char* pszKey, char* pszValue, int nValueLen)
{
	char* pszQS;

	if( pszKey == NULL )
	{
		m_pszLastError = WEBUTIL_BADPARAM;
		return 0;
	}

	if( (pszQS = m_pEnv->GetValue("QUERY_STRING")) == NULL )
	{
		m_pszLastError = WEBUTIL_BADPARAM;
		return 0;
	}

	return QueryValueFromString(pszQS, pszKey, pszValue, nValueLen);
}

//*****************************************************************************
//
// GetQueryGetQueryItemIntItemInt
//	@detail
//		QUERY_STRINGKeyɑΉvalue̒l𐔒lƂĎ擾
//		GET \bhp
//
// ----------------------------------------------------------------------------
//
//	@param
//		char* pszKey		[in ]L[
//	@return
//		int					ꂽl
//
//*****************************************************************************
int WebUtil::GetQueryItemInt(const char* pszKey)
{
	char szBuf[12]; //32bit max + NULL

	if( pszKey == NULL )
	{
		m_pszLastError = WEBUTIL_BADPARAM;
		return 0;
	}

	memset( szBuf, 0, 12 );

	if( GetQueryItem(pszKey, szBuf, 11) == 0 )
	{
		return 0;
	}

	return atoi(szBuf);
}

//*****************************************************************************
//
// GetPostItem
//	@detail
//		urlencoded񂩂KeyɑΉvalue̒l擾
//		POST \bhp
//
// ----------------------------------------------------------------------------
//
//	@param
//		const char* pszKey	[in ]L[
//		char* pszValue		[out]ꂽlobt@
//		int nValueLen		[in ]obt@̒
//								0ƃobt@ɕKvȒ擾ł
//	@return
//		int					ꂽl̒
//
//*****************************************************************************
int WebUtil::GetPostItem(const char* pszKey, char* pszValue, int nValueLen)
{
	if( !IsPost() )
		return 0;

	char* pszQS;
	char* pszEncType;

	if( pszKey == NULL )
	{
		m_pszLastError = WEBUTIL_BADPARAM;
		return 0;
	}

	if( (pszQS = (char*)m_pBody->GetBuffer()) == NULL )
		return 0;

	pszEncType = m_pEnv->GetValue("CONTENT_TYPE");

	if(IsFormUrlencoeded(m_pEnv))
	{
		return QueryValueFromString(pszQS, pszKey, pszValue, nValueLen);
	}
	else if(IsFormFromMultipart(m_pEnv) )
	{
		return QueryValueFromMultipart(pszKey, pszValue, nValueLen);
	}

	m_pszLastError = WEBUTIL_ERR_CONTENTSTYPE;
	return 0;

}

//*****************************************************************************
//
// GetPostItem
//	@detail
//		|Xgꂽurlencoded񂩂KeyɑΉvalue̒l擾
//		POST \bhp
//
// ----------------------------------------------------------------------------
//
//	@param
//		const char* pszKey	[in ]镶
//		MyVarMem* pVM		[out]ꂽl
//	@return
//		int					ꂽl̒
//
//*****************************************************************************
int WebUtil::GetPostItem(const char* pszKey, MyVarMem* pVM)
{
	if( !IsPost() )
		return 0;

	char* pszQS;
	char* pszEncType;
	int nValueLen;

	if( (pszQS = (char*)m_pBody->GetBuffer()) == NULL )
		return 0;

	pszEncType = m_pEnv->GetValue("CONTENT_TYPE");

	char* pBlock = NULL;

	if(IsFormUrlencoeded(m_pEnv))
	{
		nValueLen = GetMemoryBlockFromUrlEncoded( pszQS, pszKey, &pBlock );
		return pVM->Add( pBlock, nValueLen );
	}
	else if(IsFormFromMultipart(m_pEnv) )
	{
		return QueryValueFromMultipart(pszKey, pVM);
	}

	m_pszLastError = WEBUTIL_ERR_CONTENTSTYPE;
	return 0;
}

//*****************************************************************************
//
// GetPostItemInt
//	@detail
//		|Xgꂽ񂩂KeyɑΉvalue̒l𐔒lƂĎ擾
//		POST \bhp
//
// ----------------------------------------------------------------------------
//
//	@param
//		char* pszKey		[in ]L[
//	@return
//		int					ꂽl
//
//*****************************************************************************
int WebUtil::GetPostItemInt(const char* pszKey)
{
	char szBuf[12]; //32bit max + NULL
	memset(szBuf, 0, 12);

	if( GetPostItem(pszKey, szBuf, 11) == 0 )
		return 0;

	return atoi(szBuf);
}

//*****************************************************************************
//
// GetMemoryBlockFromMultipart
//	@detail
//		Key}`p[g̃f[^ubN𑖍AlԂ
//		POSTf[^擾
//
// ----------------------------------------------------------------------------
//
//	@param
//		char* pszKey		[in ]L[
//		char** ppBlock		POSTf[^̃AhX
//
//	@return
//		int					ꂽl̒
//
//*****************************************************************************
int WebUtil::GetMemoryBlockFromMultipart(const char* pszKey, char** ppBlock)
{
	// ------------------------------------------------------------------------
	// BODY̎擾
	// ------------------------------------------------------------------------
	char* pszContentLength = m_pEnv->GetValueI("CONTENT_LENGTH");
	if( pszContentLength == NULL )
	{
		m_pszLastError = WEBUTIL_ERR_BOUNDARYPOSTDATA;
		return 0;
	}

	int nContentLength = atoi( pszContentLength );

	// ------------------------------------------------------------------------
	// oE_擾
	// ------------------------------------------------------------------------
	char* pszContentType = m_pEnv->GetValueI("CONTENT_TYPE");
	if( pszContentType == NULL )
	{
		m_pszLastError = WEBUTIL_ERR_BOUNDARYPOSTDATA;
		return 0;
	}

	char* pszBoundary = strstr(pszContentType, "boundary=");
	if( pszBoundary == NULL )
	{
		m_pszLastError = WEBUTIL_ERR_BOUNDARYPOSTDATA;
		return 0;
	}

	pszBoundary += 9;		// strlen("boundary=") == 9
	int nBoundaryLen = strlen(pszBoundary);

	if( nContentLength <= nBoundaryLen )
	{
		m_pszLastError = WEBUTIL_ERR_BOUNDARYPOSTDATA;
		return 0;
	}

	// ------------------------------------------------------------------------
	// oE_T
	// ------------------------------------------------------------------------
	char* pContent = (char*)m_pBody->GetBuffer();
	char* p1stBodyTop = (char*)m_pBody->GetBuffer();
	char* p2ndBodyTop = NULL;
	char* pFileName = NULL;

	for( ; p1stBodyTop + nBoundaryLen +2 < pContent + nContentLength; p1stBodyTop++ )
	{
		if( memcmp(p1stBodyTop, pszBoundary, nBoundaryLen) == 0 )
		{
			// ڂ̃oE_
			p1stBodyTop += nBoundaryLen;

			// '--' ͏Ï
			if( *(p1stBodyTop) == '-' && *(p1stBodyTop + 1) == '-' )
				return 0;

			p1stBodyTop+=2;	// \r\n


			p2ndBodyTop = p1stBodyTop + 1;

			while(1)
			{
				// over flow check.
				if( p2ndBodyTop + nBoundaryLen +2 > pContent + nContentLength )
				{
					m_pszLastError = WEBUTIL_ERR_BOUNDARYPOSTDATA;
					return 0;
				}

				// ̃oE_
				if( memcmp(p2ndBodyTop, pszBoundary, nBoundaryLen) == 0 )
					break;

				p2ndBodyTop++;
			}

			// ̃oE_
			p2ndBodyTop -= 4;		// '\r\n--'

			// ----------------------------------------------------------------
			// oE_Ԃ̃p[g
			// ----------------------------------------------------------------

			// s̃`FbN
			char* pszCRLFCRLF = strstr( p1stBodyTop, "\r\n\r\n" );

			if( pszCRLFCRLF == NULL || pszCRLFCRLF > p2ndBodyTop )
			{
				m_pszLastError = WEBUTIL_ERR_BOUNDARYPOSTDATA;
				return 0;
			}

			// KEY̊mF
			char* pszNameTag = strstr( p1stBodyTop, "name=\"" );

			if( pszNameTag == NULL || pszNameTag > p2ndBodyTop)
			{
				continue;
			}

			pszNameTag += 6;

			// ----------------------------------------------------------------
			// Kvȃp[gǂ`FbN
			// ----------------------------------------------------------------
			if( 0 != strncmp( pszNameTag, pszKey, strlen(pszKey)) )
			{
				continue;
			}

			// ----------------------------------------------------------------
			// S[I
			// ----------------------------------------------------------------
			*ppBlock = pszCRLFCRLF+4;	// \r\n\r\n
			return p2ndBodyTop - *ppBlock;

		}
	}
	return 0;
}

//*****************************************************************************
//
// QueryValueFromMultipart
//	@detail
//		}`p[g̃f[^l擾
//
// ----------------------------------------------------------------------------
//
//	@param
//		const char* pszKey	[in ]镶
//		MyVarMem* pVM		[out]ꂽl
//	@return
//		int					ꂽl̒
//
//*****************************************************************************
int WebUtil::QueryValueFromMultipart(const char* pszKey, char* pszValue, int nValueLen)
{
	char* pBlockTop = NULL;
	int nBlockLen = 0;

	nBlockLen = GetMemoryBlockFromMultipart(pszKey, &pBlockTop);

	// TCY̖₢킹
	if( nValueLen == 0 )
	{
		return nBlockLen;
	}
	else if( nBlockLen > nValueLen )
	{
		// obt@I[o[
		return 0;
	}

	// obt@I[o[0Ԃ
	if( pszValue != NULL )
	{
		// s
		memcpy( pszValue, pBlockTop, nBlockLen );
	}
	return nBlockLen;
}

//*****************************************************************************
//
// QueryValueFromMultipart
//	@detail
//		|Xgꂽmultipart񂩂KeyɑΉvalue̒l擾
//		POST \bhp
//
// ----------------------------------------------------------------------------
//
//	@param
//		const char* pszKey	[in ]镶
//		MyVarMem* pVM		[out]ꂽl
//	@return
//		int					ꂽl̒
//
//*****************************************************************************
int WebUtil::QueryValueFromMultipart(const char* pszKey, MyVarMem* pVM)
{
	pVM->Clear();

	char* pBlockTop = NULL;
	int nBlockLen = 0;

	nBlockLen = GetMemoryBlockFromMultipart(pszKey, &pBlockTop);

	return pVM->Add(pBlockTop, nBlockLen);
}

//*****************************************************************************
//
// IsPost
//	@detail
//		METHOD POST̏ꍇA^
// ----------------------------------------------------------------------------
//
//	@param
//
//	@return
//
//*****************************************************************************
int WebUtil::IsPost()
{
	char* p = m_pEnv->GetValue("REQUEST_METHOD");

	if( strcmp(p, "POST") == 0 )
		return 1;
	return 0;
}

//*****************************************************************************
//
// GetScriptDir
//	@detail
//		JgfBNg擾
//
// ----------------------------------------------------------------------------
//
//	@param
//		char* pszDstName	[out]lobt@
//		int nDstNameLen		[in ]obt@
//								0̏ꍇA'\0'܂߂KvȒԂ
//	@return
//		int					:
//							s:0
//*****************************************************************************
int WebUtil::GetScriptDir(char* pszDstName, int nDstNameLen)
{
	char* pszDocmentRoot = m_pEnv->GetValue("DOCUMENT_ROOT");
	char* pszScriptName = m_pEnv->GetValue("SCRIPT_NAME");

	if( !pszDocmentRoot || !pszScriptName )
		return 0;

	int nStrLen = strlen(pszDocmentRoot) + strlen(pszScriptName);

	if( nDstNameLen == 0 )
		return nStrLen + 1;
	else if( nStrLen >= nDstNameLen )
		return 0;

	strcpy(pszDstName, m_pEnv->GetValue("DOCUMENT_ROOT"));
	strcat(pszDstName, m_pEnv->GetValue("SCRIPT_NAME"));

	char* p = pszDstName;

	do{
		if( *p == '/' )
			*p = '\\';
	}while( *p++ != '\0' );

	p--;

	while( *p != '\\' )
	{
		if( p == pszDstName ) break;

		*p-- = '\0';
	};

	return nStrLen;
}

/*
VarString::VarString() : MyVarMem(64)
{
	m_pWStr = NULL;
}

VarString::~VarString()
{
	Clear();
}

size_t VarString::Add(unsigned short* pwstrAddData)
{
	int nLen;
	char* pStr = NULL;

	nLen = WideCharToMultiByte(CP_ACP, 0, pwstrAddData, -1, NULL, 0, NULL, FALSE);
	pStr = (char*)malloc( nLen );
	memset(pStr, 0, nLen);

	if( pStr == NULL )
		return 0;

	if( 0 == WideCharToMultiByte(CP_ACP, 0, pwstrAddData, -1, pStr, nLen, NULL, FALSE) )
	{
		free( pStr );
		return 0;
	}

	nLen = MyVarMem::Add(pStr);

	free(pStr);

	return nLen;
}

void VarString::Clear()
{
	if( m_pWStr )
	{
		free( m_pWStr );
	}
	MyVarMem::Clear();
}

VarString::operator unsigned short *()
{
	int		nLen;
	char*	pStr = (char*)GetBuffer();

	nLen = MultiByteToWideChar( CP_ACP, 0, pStr, -1, NULL, 0 );

	if(nLen == 0)
	{
		return NULL;
	}

	if( m_pWStr )
	{
		free(m_pWStr);
	}

	m_pWStr = new unsigned short[nLen];
	memset( m_pWStr, 0, (nLen+1)*sizeof(unsigned short) );

	if( 0 != MultiByteToWideChar(CP_ACP, 0, pStr, -1, m_pWStr, nLen ) )
		return m_pWStr;
	else
		return NULL;
}
*/