/* =========================================================================
	This library is part of IshiSoft CEHTTP base class.
	------------------------------------------------------------------------
	author: yu-ishi@ya2.so-net.ne.jp
			http://www001.upp.so-net.ne.jp/ishi/index.html
  ========================================================================== */
#if !defined(_WEBITEM_H_INCLUDED_)
#define _WEBITEM_H_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MyHash.h"

// ---------------------------------------------
// utility function
// ---------------------------------------------
char* WStrToStrAlloc(unsigned short* pT);
unsigned long HtoDWORD(char* src);
void UnEscape( char* src );
int TOLOWER( int c );
char *STRLWR( char *string );
int STRICMP( const char *str1, const char *str2 );
int STRNICMP( const char *str1, const char *str2, size_t n );
char* STRDUP( const char* strSrc );

class WebUtil
{
/*
	GetItem
		->GetQueryItem
		->GetPostItem
			->GetValueFromMultipart
				->GetMemoryBlockFromMultipart
*/

public:
	WebUtil(MyHash* pEnv = NULL, MyVarMem* pBody = NULL, MyVarMem* pRes = NULL);
	~WebUtil();

	void Set(MyHash* pEnv, MyVarMem* pBody, MyVarMem* pRes);

	MyHash* GetEnv()	const	{return m_pEnv;}
	MyVarMem* GetBody()	const	{return m_pBody;}
	MyVarMem* GetRes()	const	{return m_pRes;}


	// Get value from post/get data
	int GetItem(const char* pszKey, MyVarMem* pvmRet);
	int GetItem(const char* pszKey, char* pszValue, int nValueLen);
	int GetItemInt(const char* pszKey);

	// Get value from GET data
	int GetQueryItem(const char* pszKey, MyVarMem* pVM);
	int GetQueryItem(const char* pszKey, char* pszValue, int nValueLen);
	int GetQueryItemInt(const char* pszKey);

	// Get vaule from POST(multipart/urlencoded) data
	int GetPostItem(const char* pszKey, MyVarMem* pVM);
	int GetPostItem(const char* pszKey, char* pszValue, int nValueLen);
	int GetPostItemInt(const char* pszKey);

	// Get value from multipart data
	int GetMemoryBlockFromMultipart(const char* pszKey, char** pBlock);
	int QueryValueFromMultipart(const char* pszKey, MyVarMem* pVM);
	int QueryValueFromMultipart(const char* pszKey, char* pszValue, int nValueLen);

	int IsPost();

	int GetScriptDir(char* pszDstName, int nDstNameLen);

//protected:
	MyHash*		m_pEnv;
	MyVarMem*	m_pBody;
	MyVarMem*	m_pRes;
	char*		m_pszLastError;
};

#endif // !defined(_WEBITEM_H_INCLUDED_)
